-- Made by fixylol
--[[
Ideas:
Pushable trees [DONE]
Circle enemies (behave like the enemies in bad guys.sim)
Ice (behaves like the ice in that club penguin game)
Multiple levels
Reset the timer when the level ends/you lose [DONE]
 ]]
timer = 0
gtimer = 0
debug = true
debounce = 0

function CalculateTilePosition(Tile)
    return 32 * (Tile - 1) + 1
end

function Respawn()
    chartilex = CurrentLevel["SpawnTileX"]
    chartiley = CurrentLevel["SpawnTileY"]
    charposx = CalculateTilePosition(chartilex)
    charposy = CalculateTilePosition(chartiley)
    timer = 0
end
function CheckCollision(d)
    if chartiley < 1 or chartilex < 1 or chartiley > 14 or chartilex > 25 then
        Respawn()
    elseif CurrentLevel[chartiley][chartilex] == 2 then
        Respawn()
    elseif CurrentLevel[chartiley][chartilex] == 3 then
        if CurrentLevelNum == 2 then
            Win()
        else
            CurrentLevelNum = CurrentLevelNum + 1
            CurrentLevel = LoadMap(CurrentLevelNum)
            Respawn()
        end
    elseif CurrentLevel[chartiley][chartilex] == 4 then
        CurrentLevel["SpawnTileX"] = chartilex
        CurrentLevel["SpawnTileY"] = chartiley
    else
        for i,v in pairs(CurrentLevel.Trees) do
            if chartilex == v[1] and chartiley == v[2] then
                print("Player at "..chartilex..","..chartiley.." moved tree at "..v[1]..","..v[2])
                if string.sub(d,2) == "x" then v[1] = d == "nx" and v[1] - 1 or v[1] + 1 end
                if string.sub(d,2) == "y" then v[2] = d == "ny" and v[2] - 1 or v[2] + 1 end
            end
        end
    end
end

function CheckEnemyCollision()

end

function LoadMap(Level)
    SampleLevel = {
        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        ["SpawnTileX"] = 1,
        ["SpawnTileY"] = 1,
        ["Trees"] = {},
        ["Enemies"] = {}
    }
    Menu = {} --that should shut it up
    Level1 = { -- size is 25x14
        {2,2,2,2,2,2,2,2,1,1,3,2,2,2,2,2,2,2,2,2,2,1,1,2,1},
        {2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {1,2,1,2,2,2,2,1,2,2,2,2,2,2,2,2,2,1,2,1,2,1,2,2,1},
        {1,2,2,1,2,1,1,1,1,2,2,2,2,2,1,2,2,2,2,2,1,2,1,2,2},
        {2,2,1,2,1,2,2,2,2,2,2,2,2,1,2,1,2,1,2,2,2,2,1,2,1},
        {1,1,2,1,2,1,2,2,2,2,2,1,2,1,2,2,2,2,2,2,1,2,2,2,2},
        {2,2,1,2,1,2,1,1,1,1,2,1,2,1,2,2,2,2,1,1,2,2,2,2,2},
        {1,2,2,1,2,1,2,2,2,2,2,1,2,1,2,2,2,2,1,2,1,2,2,2,2},
        {1,2,1,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2},
        {2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2},
        {2,2,1,2,2,2,2,2,1,1,2,2,1,1,2,2,1,1,1,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,1,2,1,1,2,1,2,2,2,1,2,1,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,1,2,2,1,2,1,2,1,2,1,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,4,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        ["SpawnTileX"] = 10,
        ["SpawnTileY"] = 14,
        ["Trees"] = {{18,11},{14,6},{12,6},{7,4}},
        ["Enemies"] = {}
    }
    Level2 = {
        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {2,2,2,2,1,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        {4,2,1,3,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2},
        ["SpawnTileX"] = 1,
        ["SpawnTileY"] = 14,
        ["Trees"] = {},
        ["Enemies"] = {{3,4,1}}
    }
    Maps = {
        ["Menu"] = Menu,
        [1] = Level1,
        [2] = Level2
    }
    return Maps[Level]
end

function Move(key)
    speed = 32
    tilespeed = 1
    if love.keyboard.isDown("space") then
        speed = 64
        tilespeed = 2
    end
    if key == "w" or key == "up" then
        if chartiley == 1 then return end
        charposy = charposy - speed
        chartiley = chartiley - tilespeed
        CheckCollision("ny")
    elseif key == "s" or key == "down" then
        if chartiley == 14 then return end
        charposy = charposy + speed
        chartiley = chartiley + tilespeed
        CheckCollision("py")
    elseif key == "a" or key == "left" then
        if chartilex == 1 then return end
        charposx = charposx - speed
        chartilex = chartilex - tilespeed
        CheckCollision("nx")
    elseif key == "d" or key == "right" then
        if chartilex == 25 then return end
        charposx = charposx + speed
        chartilex = chartilex + tilespeed
        CheckCollision("px")
    elseif key == "r" then
        if finished == false then
        Respawn()
        timer = 0
        else
        LoadMap(1)
        Respawn()
        finished = false
        end
        code = ""
    elseif key == "p" then
        if debug == false then return end
        CurrentLevelNum = CurrentLevelNum + 1
        CurrentLevel = LoadMap(CurrentLevelNum)
        Respawn()
        gtimer = 999999999
    elseif key == "m" then
        if muted then
            muted = false
        else
            muted = true
            love.audio.stop()
        end
    end
end

function love.load(arg)
    muted = false
    mver,ver,rver = love.getVersion()
    if ver ~= 10 then
        love.window.showMessageBox("Wrong version!","This game was made for LOVE 0.10.1. The game may malfunction.")
    end
    genseed = tonumber(arg[1])
    TileW, TileH = 32, 32
    charposx = 1
    charposy = 1
    chartilex = 1
    chartiley = 1
    terrain = love.graphics.newImage("terrain.png")
    titlescreen = love.graphics.newImage("awedd2.png")
    tree = love.graphics.newImage("bush.png")
    tiles = {}
    LoadMap("Menu")
    --tiles[1] = love.graphics.newQuad(0,0,32,32,terrain:getDimensions())
    tiles[1] = love.graphics.newQuad(0,0,30,30,terrain:getDimensions())
    tiles[2] = love.graphics.newQuad(31,0,60,30,terrain:getDimensions())
    tiles[3] = love.graphics.newQuad(62,0,95,30,terrain:getDimensions())
    tiles[4] = love.graphics.newQuad(0,33,30,30,terrain:getDimensions())
    tiles[5] = love.graphics.newQuad(0,62,30,30,terrain:getDimensions())
    tiles[6] = love.graphics.newQuad(31,62,30,30,terrain:getDimensions())
    tiles[7] = love.graphics.newQuad(62,62,30,30,terrain:getDimensions())

    char = love.graphics.newImage("char.png")
    badguy = love.graphics.newImage("enemy.png")
    bgm1 = love.audio.newSource("bgm1.mp3")
    timer = 0

    loaded = false
    finished = false
    won = false
end

function Win()
    won = true
end

function love.update(dt)
    debounce = debounce + dt
    if debounce >= 0.5 then
        if CurrentLevel == nil then return end
        debounce = 0
        for i,v in pairs(CurrentLevel.Enemies) do
            v[1] = v[3] == 1 and v[1] + 1 or v[3] == 3 and v[1] - 1
            v[2] = v[3] == 2 and v[2] + 1 or v[3] == 4 and v[2] - 1
        end
    end
    if loaded == true and finished == false then
        timer = timer + dt
    end
    if loaded == true and won == false then
        gtimer = gtimer + dt
    end
    if muted == false then love.audio.play(bgm1) end
end

function love.draw()
    love.graphics.setBackgroundColor(0,0,255)
    if won == true then
        local pos = love.window.toPixels(70)
        love.graphics.printf("You won! Time:"..math.floor(gtimer), pos, pos, love.graphics.getWidth() - pos)
        return
    end
    if loaded == false then
        love.graphics.draw(titlescreen,0,0,0)
        return
    end
    if CurrentLevel == nil then return end
    for rowi,rowv in pairs(CurrentLevel) do
        if rowi == "SpawnTileX" or rowi == "SpawnTileY" then break end
        for columni,columnv in pairs(rowv) do
            love.graphics.draw(terrain, tiles[columnv], (columni-1)*TileW, (rowi-1)*TileH,0,1.06)
        end
    end
    for i,v in pairs(CurrentLevel.Trees) do
        love.graphics.draw(tree, CalculateTilePosition(v[1]), CalculateTilePosition(v[2]))
    end
    for i,v in pairs(CurrentLevel.Enemies) do
        love.graphics.draw(badguy, CalculateTilePosition(v[1]), CalculateTilePosition(v[2]))
    end
    love.graphics.draw(char,CalculateTilePosition(chartilex),CalculateTilePosition(chartiley))
    love.graphics.print({{255,255,255},"Level: "..CurrentLevelNum})
    love.graphics.print({{255,255,255},"Time: "..math.floor(timer)},0,15)
end

function love.keypressed(key,scancode,isrepeat)
    if loaded == true then
        Move(key)
    else
        CurrentLevel = LoadMap(1)
        CurrentLevelNum = 1
        CheckCollision("px")
        loaded = true
    end
end